<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  computed: {
    description() {
      return this.data.seo?.fields?.description || this.data.description || '';
    },
  },
  methods: {
    formatDate(date): any {
      const tempDate = new Date(`${date}T00:00:00`);
      const options = { year: 'numeric', month: 'long', day: 'numeric' };
      return tempDate.toLocaleDateString('en-US', options);
    },
  },
});
</script>

<template>
  <client-only>
    <article class="event-card">
      <SlpRow>
        <SlpColumn :cols="8" size="md">
          <SlpTypography
            tag="h3"
            variant="heading4-bold"
            class="slp-text-align-left slp-mb-16"
            >{{ data.name }}</SlpTypography
          >
          <SlpTypography
            tag="p"
            variant="body2-bold"
            class="slp-text-align-left slp-mb-8"
            >{{ data.format }}</SlpTypography
          >
          <div
            v-if="description"
            class="slp-text-align-left event-card__description"
            v-html="$md.render(description)"
          ></div>
        </SlpColumn>
        <SlpColumn :cols="1" size="md"></SlpColumn>
        <SlpColumn :cols="3" size="md" class="event-card__dates">
          <SlpTypography
            tag="h3"
            variant="heading5-bold"
            class="event-card__right"
            >{{ formatDate(data.date) }}
          </SlpTypography>
          <SlpTypography
            v-if="data.date != data.endDate"
            tag="h3"
            variant="heading5-bold"
            class="event-card__right"
          >
            - {{ formatDate(data.endDate) }}
          </SlpTypography>
          <SlpTypography tag="p" variant="p" class="event-card__right slp-my-16"
            ><span v-if="data.location">{{ data.location }},</span>
            {{ data.region }}
          </SlpTypography>
          <div
            v-if="data.socialTags"
            class="event-card__right event-card__social-tag slp-my-16"
          >
            <SlpTypography
              v-for="tag in data.socialTags"
              :key="tag"
              tag="p"
              variant="body2"
              >#{{ tag }}</SlpTypography
            >
          </div>
        </SlpColumn>
      </SlpRow>
      <SlpRow class="slp-mt-16 event-card__button">
        <SlpButton
          :href="data.eventURL"
          data-ga-name="Join Us"
          data-ga-location="body"
          >Join Us!</SlpButton
        >
      </SlpRow>
    </article>
  </client-only>
</template>

<style lang="scss" scoped>
.event-card {
  display: block;
  background: $color-surface-50;
  border-radius: $spacing-4;
  width: 100%;
  margin: $spacing-16 0;
  padding: $spacing-48;
  color: $color-text-300;
  border: 1px solid $color-surface-200;
  box-shadow: $shadow-surface-primary-1;

  &__button {
    justify-content: end;
  }

  &__right {
    text-align: right;
  }

  &__social-tag {
    color: $color-text-200;
    font-style: italic;
  }

  &__description {
    font-size: 16px;
    line-height: 24px;
  }

  &__dates {
    @media (max-width: $breakpoint-sm) {
      width: 100%;
      margin-top: $spacing-8;
    }
  }
}
</style>
